/* Include the MCR header file and the library specific header file
* as generated by MATLAB Compiler */
#include "mclmcr.h"
#include "libfoo.h"
#include <time.h>
#include <stdio.h>

int main(int argc, char **argv)
{
	mxArray *x_ptr;
	mxArray *y_ptr=NULL;
	double *y;
	double ret;
	float input;
    size_t t1, t2;
 
    t1 = time(NULL);

	/* Call the MCR and library initialization functions */
	if( !mclInitializeApplication(NULL,0) )
	{
		fprintf(stderr, "Could not initialize the application.\n");
		exit(1);
	}

	if (!libfooInitialize())
	{
		fprintf(stderr,"Could not initialize the library.\n");
		exit(1);
	}

	sscanf(argv[1], "%f", &input);
	
	/* Create an mxArray to input into mlfFoo */
	x_ptr = mxCreateDoubleScalar(input);

	/* Call the implementation function */
	/* Note the second input argument should be &y_ptr instead of y_ptr*/
	mlfFoo(1,&y_ptr,x_ptr);

	/* The return value from mlfFoo is an mxArray so we must extract the data from it */
	y = mxGetPr(y_ptr);
	ret = *y;
	
	/* Print a double precision number*/
	printf("The output of foo is %f\n",ret);

	/* Call the library termination function */
	libfooTerminate();

	mxDestroyArray(x_ptr);
	mxDestroyArray(y_ptr);
	mclTerminateApplication();
	
    t2 = time(NULL);
    div_t divresult;
    divresult = div (t2-t1, 60);
    warn("Process time = %d min %d sec\n", divresult.quot, divresult.rem);
	return 0;
}

